
# Vue.js Router for Everyone

[![](https://vueschool.io/media/832cd8ca9658529790923877c565a22f/master-the-vuejs-router-by-building-a-travel-app.jpeg)](https://vueschool.io/courses/vue-router-for-everyone)

This repository contains the example code for the [Vue.js Router for Everyone](https://vueschool.io/courses/vue-router-for-everyone) course on [Vue School](https://vueschool.io).

Learn how to create powerful Vue.js Single Page Applications (SPA’s) with the Vue Router in this course.

Single Page Applications are web apps or sites that interact with the user by dynamically rewriting the current page rather than loading entire new pages from the server.

This approach allows us to only fetch the data/section of our page that is needed when a user interacts with our app. By dynamically rewriting smaller chunks of our site, it prevents us from re-downloading already loaded resources such as the images, scripts, CSS, etc.

As a result SPA’s tend to improve the user experience due to its impressive page load speed performance and behave more like desktop applications.

In this course, you’ll learn everything you need to know about the Vue Router to either create rapid prototypes or ımpressive, full-blown Vue.js SPA’s.

**By the end of this course you will master**
- How to scaffold a new Vue.js project, including the Vue Router with Vue CLI GUI
- How to create routes, including named routes
- Learn how to lazy load your routes
- Learn how to work with Vue Router Params and pass them as props to components
- How to create dynamic and nested routes
- Learn what the HTML5 History Mode is and how to enable it
- Learn how to create impressive route transitions
- How to create a 404 page with the Vue Router
- Learn what navigation guards are and how to create an authentication middleware for your app
- And much much more.

You need a basic understanding of Vue.js to enjoy this course. We recommend watching [Vue.js Components Fundamentals](https://vueschool.io/courses/vuejs-components-fundamentals) and [Vue.js Components Fundamentals](https://vueschool.io/courses/vuejs-components-fundamentals) if you’re not already familiar with Vue.js and components.

[Click here to watch the Vue.js Router for Everyone course](https://vueschool.io/courses/vue-router-for-everyone).

---



## Project setup
```
npm install
```

### Compiles and hot-reloads for development
```
npm run serve
```

### Compiles and minifies for production
```
npm run build
```

### Run your tests
```
npm run test
```

### Lints and fixes files
```
npm run lint
```

